%global gem_name redis
Name:                rubygem-%{gem_name}
Version:             4.7.0
Release:             2
Summary:             A Ruby client library for Redis
License:             MIT
URL:                 https://github.com/redis/redis-rb
Source0:             https://rubygems.org/gems/%{gem_name}-%{version}.gem
Source1:             https://github.com/redis/redis-rb/archive/refs/tags/v%{version}.tar.gz
BuildRequires:       ruby ruby(release) rubygems-devel rubygem(test-unit) redis make rubygem(hiredis) rubygem(minitest) rubygem(mocha) procps-ng
BuildArch:           noarch
%description
A Ruby client that tries to match Redis' API one-to-one, while still
providing an idiomatic interface.

%package doc
Summary:             Documentation for %{name}
Requires:            %{name} = %{version}-%{release}
BuildArch:           noarch
%description doc
Documentation for %{name}.

%prep
%setup -q -n %{gem_name}-%{version} -b 1

%build
gem build ../%{gem_name}-%{version}.gemspec
%gem_install

%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

%check
pushd .%{gem_instdir}
cp -a %{_builddir}/redis-rb-%{version}/{makefile,test} .
sed -i "s/bundle exec rake test/ruby -Ilib:test -e \"Dir.glob('.\/test\/**\/*_test.rb').sort.each {|t| require t}\"/" \
  makefile

# The TestInternals#test_large_payload fails with Hiredis.
# https://github.com/redis/redis-rb/issues/1117
sed -i \
  -e '/def test_large_payload/i\  driver(:ruby) do' \
  -e '/def test_large_payload/,/end/ {/end/ s/end/&\n  end/;}' \
  test/internals_test.rb

mkdir bin
echo '#!/usr/bin/sh' > bin/build
chmod a+x bin/build
mv %{_builddir}/redis-rb-%{version}/bin/cluster_creator bin/
LANG=C.UTF-8
pkill -f redis-server || true
sleep 5
for driver in ruby hiredis ; do
export DRIVER=$driver
make BINARY=$(which redis-server) REDIS_CLIENT=$(which redis-cli) BUILD_DIR='${TMP}'
sleep 5
done
popd


%files
%dir %{gem_instdir}
%{gem_libdir}
%license %{gem_instdir}/LICENSE
%{gem_spec}
%exclude %{gem_cache}
%exclude %{gem_instdir}/.*

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CHANGELOG.md
%doc %{gem_instdir}/README.md

%changelog
* Sat Nov 5 2022 caodongxia <caodongxia@h-partners.com> - 4.7.0-2
- The TestInternals#test_large_paylod fails with hiredis

* Tue Oct 25 2022 caodongxia <caodongxia@h-partners.com> - 4.7.0-1
- Update to 4.7.0

* Tue Aug 18 2020 huangyangke <huangyangke@huawei.com> - 4.0.1-1
- package init
